package edu.cmu.paid.authentication;

import java.util.*;
import edu.cmu.paid.database.storage.*;
import edu.cmu.paid.authentication.util.ByteConverterWrapper;
import edu.cmu.paid.authentication.Exception.*;


public class MakeUsers {

  public static void main(String args[]) {
    Group g1,g2,g3;
    User u1,u2,u3,u4,u5,u6,u7,u8,u9;

    g1 = new Group(1,"Daimler-Benz Service Manager");
    g2 = new Group(2,"Service Manager");
    g3 = new Group(3,"Mechanic");

  
    Vector acc1,acc2,acc3;

    acc1 = new Vector(5);
    acc2 = new Vector(2);
    acc3 = new Vector(3); // Non-affiliated dealer

    acc1.addElement(new Integer(Authentication.PARTS_APPID));
    acc1.addElement(new Integer(Authentication.CUSTOMER_APPID));
    acc1.addElement(new Integer(Authentication.DEALERADMIN_APPID));
    acc1.addElement(new Integer(Authentication.DOWNLOADMGMT_APPID));
    acc1.addElement(new Integer(Authentication.UPDATEMGMT_APPID));

    acc2.addElement(new Integer(Authentication.PARTS_APPID));
    acc2.addElement(new Integer(Authentication.CUSTOMER_APPID));
    //    acc2.addElement(new Integer(Authentication.UPDATEMGMT_APPID));

    acc3.addElement(new Integer(Authentication.PARTS_APPID));
    acc3.addElement(new Integer(Authentication.CUSTOMER_APPID));
    acc3.addElement(new Integer(Authentication.DEALERADMIN_APPID));
    try {
      g1.setAccessibleWindows(acc1);
      g2.setAccessibleWindows(acc3);
      g3.setAccessibleWindows(acc2);
    }
    catch (AccessAlreadyExistsException e) {
      System.out.println("Group access already set! Failing.");
      return;
    }
    finally {
      System.out.println("");
    }

    AuthData.initAuthData();
    System.out.println("Database initialized... Beginning to add groups...");
  
    byte [] serG1,serG2,serG3;
    serG1 = ByteConverterWrapper.toByteArray(g1);
    serG2 = ByteConverterWrapper.toByteArray(g2);
    serG3 = ByteConverterWrapper.toByteArray(g3);

    AuthData.addGroupProfile(g1.getGroupID(),serG1);
    AuthData.addGroupProfile(g2.getGroupID(),serG2);
    AuthData.addGroupProfile(g3.getGroupID(),serG3);

    System.out.println("Groups have been added to the database.");
    System.out.println("\nCreating users.");

    byte[] k1,k2,k3,k4;

    k1 = ByteConverterWrapper.toByteArray(98980101);
    k2 = ByteConverterWrapper.toByteArray(45452323);
    k3 = ByteConverterWrapper.toByteArray(21216767);
    k4 = ByteConverterWrapper.toByteArray(11001100);
    
    u1 = new User(0,k1,1,"Pooja","Saksena");
    u2 = new User(2,k2,1,"Qiang","Rao");
    u3 = new User(3,k3,1,"David","Garmire");
    u4 = new User(4,k4,2,"Arnaldo","Piccinelli - NonAffiliated");

    u5 = new User(10,k1,3,"Georgios","Markakis");      // Affiliated user, dealership 3
    u6 = new User(20,k2,4,"Reynald","Ong");           // Non-Affiliated dealer, dealership 4
    u7 = new User(30,k3,3,"Andrew","Zimdars");       // Affiliated dealer, dealership 3
    u8 = new User(40,k4,5,"Rudy","Setiawan");       // Affiliated dealer, dealership 5
    u9 = new User(50,k1,3,"Arnaldo","Piccinelli"); // Mechanic, dealership 3

    u1.assignUserGroup(1);
    u2.assignUserGroup(2);
    u3.assignUserGroup(1);
    u4.assignUserGroup(3);

    u5.assignUserGroup(1);  // Affiliated
    u6.assignUserGroup(2);  // Non-affiliated
    u7.assignUserGroup(1);  // Affiliated
    u8.assignUserGroup(1);  // Affiliated
    u9.assignUserGroup(3);  // Mechanic

    try {
      System.out.println("Georgios has been assigned to group "+u5.getUserGroups());
      System.out.println("Reynald has been assigned to group "+u6.getUserGroups());
      System.out.println("Andrew has been assigned to group "+u7.getUserGroups());
      System.out.println("Rudy has been assigned to group "+u8.getUserGroups());
      System.out.println("Arnaldo has been assigned to group "+u9.getUserGroups());
    } catch (Exception e) {
      System.out.println("caught an exception...");
    }
    System.out.println("Users have been defined. Now trying to insert into database.");

    byte[] u1b, u2b, u3b, u4b, u5b, u6b, u7b, u8b, u9b;
    u1b = ByteConverterWrapper.toByteArray(u1);
    u2b = ByteConverterWrapper.toByteArray(u2);
    u3b = ByteConverterWrapper.toByteArray(u3);
    u4b = ByteConverterWrapper.toByteArray(u4);
    u5b = ByteConverterWrapper.toByteArray(u5);
    u6b = ByteConverterWrapper.toByteArray(u6);
    u7b = ByteConverterWrapper.toByteArray(u7);
    u8b = ByteConverterWrapper.toByteArray(u8);
    u9b = ByteConverterWrapper.toByteArray(u9);

    try {
      AuthData.addUserProfile(u1.getUserID(),u1b);
      AuthData.addUserProfile(u2.getUserID(),u2b);
      AuthData.addUserProfile(u3.getUserID(),u3b);
      AuthData.addUserProfile(u4.getUserID(),u4b);
      AuthData.addUserProfile(u5.getUserID(),u5b);
      AuthData.addUserProfile(u6.getUserID(),u6b);
      AuthData.addUserProfile(u7.getUserID(),u7b);
      AuthData.addUserProfile(u8.getUserID(),u8b);
      AuthData.addUserProfile(u9.getUserID(),u9b);
    }
    catch (NoUserException e) {
      System.out.println("Caught a NoUser Exception.\nDatabase init failed!");
      return;
    }
    finally {
      System.out.println("");
    }

    System.out.println("Users loaded successfully into database.");
    
    return;
  }
}
